BF.events = {};

function BF.events.OnLoad( this )
	this:RegisterForClicks( "LeftButton", "RightButton" );
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("SAVE_VARIABLES");
	this:RegisterEvent("LOADING_END");
end;

function BF.events.OnEvent( this, event )
	if( event == "VARIABLES_LOADED" )then
		BF.events.VariablesLoaded( this );
	end;
	if( event == "LOADING_END" )then
		BF.tools.PlaceControls( "BFPlayerBuff", "Player" );
		BF.tools.PlaceControls( "BFTargetBuff", "Target" );
		BF.tools.PlaceControls( "BFTargetTargetBuff", "TargetTarget" );
	end;
end;

function BF.events.VariablesLoaded( this )
	local hRet;
	hRet, BFVariables = MLib.CheckVariables( BFVariables, BF.DefaultConfig );
	if( hRet == MLIB_CHECKVARIABLES_FAILED )then
		BF.Message( "|cffFF0000Ошибка запуска! Исполнение прекращено!|r" );
		BF.PANIC = true;
		return nil;
	end;
	SaveVariables("BFVariables");

	BFVariables.ShowCastBars = false;
	
	local _scale = GetUIScale();
	
	---  PLAYER Buffs  ---
	BFPlayerBuff:ClearAllAnchors();
	BFPlayerBuff:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, BFVariables.Player.X / _scale, BFVariables.Player.Y / _scale );

	BFPlayerBuffAnchor.ConfigField = "Player";
	BFPlayerSizer.ConfigField = "Player";
	BFPlayerBuffAnchor.FrameName = "Бафы игрока";
	---  /PLAYER Buffs  ---
	
	---  TARGET Buffs  ---
	BFTargetBuff:ClearAllAnchors();
	BFTargetBuff:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, BFVariables.Target.X / _scale, BFVariables.Target.Y / _scale );

	BFTargetBuffAnchor.ConfigField = "Target";
	BFTargetSizer.ConfigField = "Target";
	BFTargetBuffAnchor.FrameName = "Бафы цели";
	---  /TARGET Buffs  ---
	
	---  TARGETTARGET Buffs  ---
	BFTargetTargetBuff:ClearAllAnchors();
	BFTargetTargetBuff:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, BFVariables.TargetTarget.X / _scale, BFVariables.TargetTarget.Y / _scale );

	BFTargetTargetBuffAnchor.ConfigField = "TargetTarget";
	BFTargetTargetSizer.ConfigField = "TargetTarget";
	BFTargetTargetBuffAnchor.FrameName = "Бафы цели цели";
	---  /TARGET Buffs  ---
	
	
	BFPlayerCastBar:ClearAllAnchors();
	BFPlayerCastBar:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, BFVariables.CastBars.Player.X / _scale, BFVariables.CastBars.Player.Y / _scale );
	BFPlayerCastBar.unit = "player";
	BFPlayerCastBar.ConfigField = "Player";
	BFPlayerCastBarSizer.ConfigField = "Player";
	BFPlayerCastBar.FrameName = "Прогресс каста";
	BFPlayerCastBar.Lock = false;
	
	BFTargetCastBar:ClearAllAnchors();
	BFTargetCastBar:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, BFVariables.CastBars.Target.X / _scale, BFVariables.CastBars.Target.Y / _scale );
	BFTargetCastBar.unit = "target";
	BFTargetCastBar.ConfigField = "Target";
	BFTargetCastBarSizer.ConfigField = "Target";
	BFTargetCastBar.FrameName = "Прогресс каста цели";
	BFTargetCastBar.Lock = false;

	BFTargetTargetCastBar:ClearAllAnchors();
	BFTargetTargetCastBar:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, BFVariables.CastBars.TargetTarget.X / _scale, BFVariables.CastBars.TargetTarget.Y / _scale );
	BFTargetTargetCastBar.unit = "targettarget";
	BFTargetTargetCastBar.ConfigField = "TargetTarget";
	BFTargetTargetCastBarSizer.ConfigField = "TargetTarget";
	BFTargetTargetCastBar.FrameName = "Прогресс каста цели цели";
	BFTargetTargetCastBar.Lock = false;

	
	BF.Message( BF.Name .. " " .. BF.Version .. " успешно запущен" );
	BF.InitDone = true;
end;

function BF.events.OnClick( this, key )
	if( not IsShiftKeyDown() )and( not IsCtrlKeyDown() )and( not IsAltKeyDown() )and( key == "RBUTTON" )then
		if( not MLib.ControlsDown() )then
			PlaySoundByPath( "sound/interface/ui_dropdown_open.mp3" );
			ToggleDropDownMenu( BFOptionMenu );
		end;
	end;
end;

function BF.events.OnUpdate( this, elapsedTime )
	if( not BFVariables.Enabled )then
		if( BFPlayerBuff:IsVisible() )then BFPlayerBuff:Hide(); end;
		return nil;
	end;
	
	if( BFVariables.ShowAnchors )then
		BFPlayerBuffAnchor:Show();
		BFTargetBuffAnchor:Show();
		BFTargetTargetBuffAnchor:Show();
		BFPlayerCastBarAnchor:Show();
		BFTargetCastBarAnchor:Show();
		BFTargetTargetCastBarAnchor:Show();
	else
		BFPlayerBuffAnchor:Hide();
		BFTargetBuffAnchor:Hide();
		BFTargetTargetBuffAnchor:Hide();
		BFPlayerCastBarAnchor:Hide();
		BFTargetCastBarAnchor:Hide();
		BFTargetTargetCastBarAnchor:Hide();
	end;
	
	if( BFVariables.ShowCastBars )then
		BFPlayerCastBar.Lock = true;
		BFPlayerCastBarGauge:SetAlpha( 1 );
		BFTargetCastBar.Lock = true;
		BFTargetCastBarGauge:SetAlpha( 1 );
		BFTargetTargetCastBar.Lock = true;
		BFTargetTargetCastBarGauge:SetAlpha( 1 );
	else
		BFPlayerCastBar.Lock = false;
		BFTargetCastBar.Lock = false;
		BFTargetTargetCastBar.Lock = false;
	end;
	
	if( BFVariables.CastBars.Player.Enabled )then
		if( not BFPlayerCastBar:IsVisible() )then BFPlayerCastBar:Show(); end;
	else
		if( BFPlayerCastBar:IsVisible() )then BFPlayerCastBar:Hide(); end;
	end;
	if( BFVariables.CastBars.Target.Enabled )then
		if( not BFTargetCastBar:IsVisible() )then BFTargetCastBar:Show(); end;
	else
		if( BFTargetCastBar:IsVisible() )then BFTargetCastBar:Hide(); end;
	end;
	if( BFVariables.CastBars.TargetTarget.Enabled )then
		if( not BFTargetTargetCastBar:IsVisible() )then BFTargetTargetCastBar:Show(); end;
	else
		if( BFTargetTargetCastBar:IsVisible() )then BFTargetTargetCastBar:Hide(); end;
	end;
	
	if( BFVariables.Player.Enabled )then
		PlayerBuffFrame:Hide(); -- !!!
		-- !!!
		for n = 1, 32 do
			_G[ "TargetBuffButton" .. n ]:Hide();
			_G[ "TargetBuffButton" .. n ]:ClearAllAnchors();
			_G[ "TargetBuffButton" .. n ]:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, 0, 0 );

			_G[ "TargetDebuffButton" .. n ]:Hide();
			_G[ "TargetDebuffButton" .. n ]:ClearAllAnchors();
			_G[ "TargetDebuffButton" .. n ]:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, 0, 0 );
		end;
		-- !!!
		for n = 1, 8 do
			_G[ "TargetTargetFrameBuff" .. n ]:Hide();
			_G[ "TargetTargetFrameBuff" .. n ]:ClearAllAnchors();
			_G[ "TargetTargetFrameBuff" .. n ]:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, 0, 0 );
			_G[ "TargetTargetFrameDebuff" .. n ]:Hide();
			_G[ "TargetTargetFrameDebuff" .. n ]:ClearAllAnchors();
			_G[ "TargetTargetFrameDebuff" .. n ]:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, 0, 0 );
		end;
	end;
	
	if( this.Time == nil )then this.Time = 0; end;
	this.Time = this.Time + elapsedTime;
	if( this.Time < 0.15 )then return nil; end;
	this.Time = 0;
	
	local buffs = BF.tools.GrabUnitBuffs( "player", "buff" );
	local debuffs = BF.tools.GrabUnitBuffs( "player", "debuff" );
	local tbuffs = BF.tools.GrabUnitBuffs( "target", "buff" );
	local tdebuffs = BF.tools.GrabUnitBuffs( "target", "debuff" );
	local ttbuffs = BF.tools.GrabUnitBuffs( "targettarget", "buff" );
	local ttdebuffs = BF.tools.GrabUnitBuffs( "targettarget", "debuff" );
	
	if( not BFVariables.Player.Enabled )then
		if( BFPlayerBuff:IsVisible() )then BFPlayerBuff:Hide(); end;
	else
		if( not BFPlayerBuff:IsVisible() )then BFPlayerBuff:Show(); end;
		PlayerBuffFrame:Hide(); -- !!!
		for n = 1, 80 do
			_G[ "BFPlayerBuff" .. n ].struc = buffs[ n ];
			_G[ "BFPlayerBuffD" .. n ].struc = debuffs[ n ];
			if( _G[ "SUI_BuffButton" .. n ] ~= nil )then _G[ "SUI_BuffButton" .. n ]:Hide(); end;
			if( _G[ "SUI_DebuffButton" .. n ] ~= nil )then _G[ "SUI_DebuffButton" .. n ]:Hide(); end;
		end;
		BF.tools.PaintControls( "BFPlayerBuff", "Player", buffs, debuffs )
	end;

	if( not BFVariables.Target.Enabled )then
		if( BFTargetBuff:IsVisible() )then BFTargetBuff:Hide(); end;
	else
		if( not BFTargetBuff:IsVisible() )then BFTargetBuff:Show(); end;
		-- !!!
		for n = 1, 32 do
			_G[ "TargetBuffButton" .. n ]:Hide();
			_G[ "TargetDebuffButton" .. n ]:Hide();
		end;
		for n = 1, 80 do
			_G[ "BFTargetBuff" .. n ].struc = tbuffs[ n ];
			_G[ "BFTargetBuffD" .. n ].struc = tdebuffs[ n ];
		end;
		BF.tools.PaintControls( "BFTargetBuff", "Target", tbuffs, tdebuffs )
	end;

	if( not BFVariables.TargetTarget.Enabled )then
		if( BFTargetTargetBuff:IsVisible() )then BFTargetTargetBuff:Hide(); end;
	else
		if( not BFTargetTargetBuff:IsVisible() )then BFTargetTargetBuff:Show(); end;
		-- !!!
		for n = 1, 8 do
			_G[ "TargetTargetFrameBuff" .. n ]:Hide();
			_G[ "TargetTargetFrameDebuff" .. n ]:Hide();
		end;
		for n = 1, 80 do
			_G[ "BFTargetTargetBuff" .. n ].struc = ttbuffs[ n ];
			_G[ "BFTargetTargetBuffD" .. n ].struc = ttdebuffs[ n ];
		end;
		BF.tools.PaintControls( "BFTargetTargetBuff", "TargetTarget", ttbuffs, ttdebuffs )
	end;
end;

function BF.events.MinimapShowHint( this )
	MLib.TT.Init( this, BF.Name .. " " .. BF.Version, 260, MLib.TT.AnchorType( this ), 0, 0 );
	MLib.TT.Space();
	
	MLib.TT.LineEx( "", BFVariables.Enabled, "ВКЛЮЧЕН!", "ВЫКЛЮЧЕН!" );

	MLib.TT.Space();

	MLib.TT.LineEx( "Якоря панелей: ", BFVariables.ShowAnchors, "показаны", "скрыты" );

	MLib.TT.Space();

	MLib.TT.LineEx( "Бафы игрока: ", BFVariables.Player.Enabled, "включены", "выключены" );
	MLib.TT.LineEx( "Бафы цели: ", BFVariables.Target.Enabled, "включены", "выключены" );
	MLib.TT.LineEx( "Бафы цели цели: ", BFVariables.TargetTarget.Enabled, "включены", "выключены" );

	MLib.TT.Space();

	MLib.TT.LineEx( "Кастбар игрока: ", BFVariables.CastBars.Player.Enabled, "включен", "выключен" );
	MLib.TT.LineEx( "Кастбар цели: ", BFVariables.CastBars.Target.Enabled, "включен", "выключен" );
	MLib.TT.LineEx( "Кастбар цели цели: ", BFVariables.CastBars.TargetTarget.Enabled, "включен", "выключен" );
	
	MLib.TT.Space();
	MLib.TT.Line( UI_MINIMAPBUTTON_MOVE, 0, 0.75, 0.95 );
end;

function BF.events.OptionsMenu()
	if( UIDROPDOWNMENU_MENU_LEVEL == 1 )then
		MLib.DD.AddNormal( "Включен", "BFVariables", "Enabled", UIDROPDOWNMENU_MENU_LEVEL, BFOptionMenu );
		MLib.DD.AddNormal( "Показать якоря", "BFVariables", "ShowAnchors", UIDROPDOWNMENU_MENU_LEVEL, BFOptionMenu );
		MLib.DD.AddArrow( "Панели", "Frames", UIDROPDOWNMENU_MENU_LEVEL );
		MLib.DD.AddArrow( "Кастбары", "CastBars", UIDROPDOWNMENU_MENU_LEVEL );
		MLib.DD.AddNormal( "Показать кастбары", "BFVariables", "ShowCastBars", UIDROPDOWNMENU_MENU_LEVEL, BFOptionMenu );
	elseif( UIDROPDOWNMENU_MENU_LEVEL == 2 )then
		if( UIDROPDOWNMENU_MENU_VALUE == "Frames" )then
			MLib.DD.AddFunction( "Игрока", function() BFVariables.Player.Enabled = not BFVariables.Player.Enabled; end, UIDROPDOWNMENU_MENU_LEVEL, BFOptionMenu, BFVariables.Player.Enabled );
			MLib.DD.AddFunction( "Цели", function() BFVariables.Target.Enabled = not BFVariables.Target.Enabled; end, UIDROPDOWNMENU_MENU_LEVEL, BFOptionMenu, BFVariables.Target.Enabled );
			MLib.DD.AddFunction( "Цели цели", function() BFVariables.TargetTarget.Enabled = not BFVariables.TargetTarget.Enabled; end, UIDROPDOWNMENU_MENU_LEVEL, BFOptionMenu, BFVariables.TargetTarget.Enabled );
		end;
		if( UIDROPDOWNMENU_MENU_VALUE == "CastBars" )then
			MLib.DD.AddFunction( "Игрока", function() BFVariables.CastBars.Player.Enabled = not BFVariables.CastBars.Player.Enabled; end, UIDROPDOWNMENU_MENU_LEVEL, BFOptionMenu, BFVariables.CastBars.Player.Enabled );
			MLib.DD.AddFunction( "Цели", function() BFVariables.CastBars.Target.Enabled = not BFVariables.CastBars.Target.Enabled; end, UIDROPDOWNMENU_MENU_LEVEL, BFOptionMenu, BFVariables.CastBars.Target.Enabled );
			MLib.DD.AddFunction( "Цели цели", function() BFVariables.CastBars.TargetTarget.Enabled = not BFVariables.CastBars.TargetTarget.Enabled; end, UIDROPDOWNMENU_MENU_LEVEL, BFOptionMenu, BFVariables.CastBars.TargetTarget.Enabled );
		end;
	end;
end;

function BF.events.ItemHint( this )
	if( this.struc == nil )then return nil; end;
	GameTooltip:SetOwner( this, MLib.TT.AnchorType( this ), 0, 0 );
	local custom = "GUID: " .. this.struc.guid;

	if( this.struc.type == "buff" )then
		GameTooltip:SetUnitBuff( this.struc.unit, this.struc.index );
	else
		GameTooltip:SetUnitDebuff( this.struc.unit, this.struc.index );
	end;
	GameTooltip:AddSeparator();
	GameTooltip:AddLine( custom );
	

	if( this.struc.type == "debuff" )and( GameTooltip:IsVisible() )then
		if( GameTooltipTextLeft2:GetText():match( TEXT( "SYS_MAGIC_TYPE10" ) ) )then
			BFVariables.Curses[ this.struc.guid ] = true;
			custom = custom .. " |cff33FF33[" .. TEXT( "SYS_MAGIC_TYPE10" ) .. "]|r";
		end;
		if( GameTooltipTextLeft2:GetText():match( TEXT( "SYS_MAGIC_TYPE07" ) ) )then
			BFVariables.Poisons[ this.struc.guid ] = true;
			custom = custom .. " |cff3333FF[" .. TEXT( "SYS_MAGIC_TYPE07" ) .. "]|r";
		end;
	end;
end;

function BF.events.AnchorMouseDown( this, key )
	if( this.ConfigField == nil )then return nil; end;

	if( IsShiftKeyDown() )and( not IsCtrlKeyDown() )and( not IsAltKeyDown() )and( key == "RBUTTON" )then
		this.IsMoving = true;
		this:GetParent():StartMoving( "TOPLEFT" );
	end;

	if( not IsShiftKeyDown() )and( IsCtrlKeyDown() )and( not IsAltKeyDown() )and( key == "RBUTTON" )then
		if( BFVariables[ this.ConfigField ].Dir == 0 )then
			BFVariables[ this.ConfigField ].Dir = 1;
		else
			BFVariables[ this.ConfigField ].Dir = 0;
		end;
		BF.tools.PlaceControls( "BF" .. this.ConfigField .. "Buff", this.ConfigField );
	end;

	if( not IsShiftKeyDown() )and( IsCtrlKeyDown() )and( not IsAltKeyDown() )and( key == "LBUTTON" )then
		local sizer = _G[ "BF" .. this.ConfigField .. "Sizer" ];
		if( sizer:IsVisible() )then
			sizer:Hide();
		else
			sizer:ClearAllAnchors();
			if( BFVariables[ this.ConfigField ].Dir == 0 )then
				sizer:SetAnchor( "BOTTOMLEFT", "TOPLEFT", this, 0, -3 );
			else
				sizer:SetAnchor( "BOTTOMRIGHT", "TOPRIGHT", this, 0, -3 );
			end;
			sizer:SetValueStepMode("INT");
			sizer:SetMinMaxValues( 16, 32 );
			_G[ sizer:GetName() .. "Low" ]:SetText( "16" );
			_G[ sizer:GetName() .. "High" ]:SetText( "32" );
			sizer:SetValue( BFVariables[ this.ConfigField ].Size );
			sizer:Show();
		end;
	end;
end;

function BF.events.AnchorMouseUp( this )
	if( not this.IsMoving )then return nil; end;
	this:GetParent():StopMovingOrSizing();
	BFVariables[ this.ConfigField ]["X"], BFVariables[ this.ConfigField ]["Y"] = this:GetParent():GetPos();
end;

function BF.events.AnchorHint( this )
	if( this.FrameName == nil )then return nil; end;
	this:SetAlpha( 1 );
	MLib.TT.Init( this, BF.Name .. " " .. BF.Version, 260, MLib.TT.AnchorType( this ), 0, 0 );
	MLib.TT.Space();
	MLib.TT.Line( this.FrameName );
	MLib.TT.Space();
	MLib.TT.Line( "Shift + Правая кнопка мыши для перетаскивания", 0, 0.75, 0.95 );
	MLib.TT.Line( "Ctrl + Левая кнопка мыши для изменения размера", 0, 0.75, 0.95 );
	MLib.TT.Line( "Ctrl + Правая кнопка мыши для смены направления", 0, 0.75, 0.95 );
end;

function BF.events.ItemOnClick( this, key )
	if( this.struc.unit ~= "player" )then return nil; end;
	if( this.struc.type ~= "buff" )then return nil; end;
	if( not IsShiftKeyDown() )and( not IsCtrlKeyDown() )and( not IsAltKeyDown() )and( key == "RBUTTON" )then
		CancelPlayerBuff( this.struc.index );
	end;
end;

function BF.events.AnchorOnSize( this )
	GCF_Slider_OnValueChanged( this );
	if( not this:IsVisible() )then return nil; end;
	BFVariables[ this.ConfigField ].Size = this:GetValue();
	BF.tools.PlaceControls( "BF" .. this.ConfigField .. "Buff", this.ConfigField );
end;




function BF.events.CastBarOnLoad( this )
	CastingBarFrame:UnregisterEvent("CASTING_START");
	CastingBarFrame:UnregisterEvent("CASTING_STOP");
	CastingBarFrame:UnregisterEvent("CASTING_FAILED");
	CastingBarFrame:UnregisterEvent("CASTING_DELAYED");
	if( SUI_CastingBarFrame ~= nil )then
		SUI_CastingBarFrame:UnregisterEvent("CASTING_START");
		SUI_CastingBarFrame:UnregisterEvent("CASTING_STOP");
		SUI_CastingBarFrame:UnregisterEvent("CASTING_FAILED");
		SUI_CastingBarFrame:UnregisterEvent("CASTING_DELAYED");
	end;
	this:RegisterEvent("CASTING_START");
	this:RegisterEvent("CASTING_STOP");
	this:RegisterEvent("CASTING_FAILED");
	this:RegisterEvent("CASTING_DELAYED");
	_G[ this:GetName() .. "Gauge" ]:SetAlpha( 0 );
	_G[ this:GetName() .. "Anchor" ]:SetAlpha( 0.2 );
end;

function BF.events.CastBarOnShow( this )
end;

function BF.events.CastBarOnEvent( this, event )
	if( not BFVariables.CastBars.Player.Enabled )then
		return nil;
	end;
	local gauge = _G[ this:GetName() .. "Gauge" ];
	this:SetSize( BFVariables.CastBars.Player.Size, math.floor( BFVariables.CastBars.Player.Size / 10 ) );
	if( event == "CASTING_START" )then
		this.min = GetTime();
		this.max = this.min + arg2;
		this.cast = true;
		this.hide = false;
		this.name = arg1;
		this.maxValue = arg2;
		gauge:SetAlpha( 1 );
		gauge:SetBarColor( 0.1, 0.7, 0.7 );
		gauge:SetMinValue( this.min );
		gauge:SetMaxValue( this.max );
		gauge:SetValue( this.min );
		gauge:Show();
	elseif( event == "CASTING_FAILED" )then
		if( gauge:IsVisible() )then
			gauge:SetBarColor( 1, 0, 0 );
			gauge:SetValue( this.max );
			this.cast = false;
			this.hide = true;
		end
	elseif( event == "CASTING_STOP" )then
		if( gauge:IsVisible() )then
			gauge:SetBarColor( 0, 1, 0 );
			gauge:SetValue( this.max );
			this.cast = false;
			this.hide = true;
		end
	elseif( event == "CASTING_DELAYED" )then
		if( gauge:IsVisible() )then
			this.min = this.min + arg1;
			this.max = this.max + arg1;
			gauge:SetMinValue( this.min );
			gauge:SetMaxValue( this.max );
		end
	end;
end;

function BF.events.CastBarOnUpdate( this, elapsedTime )
	if( this.Lock )then return nil; end;
	local gauge = _G[ this:GetName() .. "Gauge" ];
	
	if( this.cast )then
		local currTime = GetTime();
		if( currTime > this.max )then
			currTime = this.max;
		end;
		gauge:SetValue( currTime );
		local curr = this.maxValue - ( this.max - GetTime() );
		if( curr > this.maxValue )then curr = this.maxValue; end;
		_G[ gauge:GetName() .. "Name" ]:SetText( this.name .. " - " .. string.format( "%.1f", curr ) .. "/" .. string.format( "%.1f", this.maxValue ) );
	elseif( this.hide )then
		local alpha = gauge:GetAlpha() - CASTING_BAR_ALPHA_STEP;
		if( alpha > 0 )then
			gauge:SetAlpha( alpha );
		else
			this.fail = false;
			gauge:Hide();
		end
	end;
end;

function BF.events.UnitCastBarOnLoad( this )
	TargetCastingBar:UnregisterEvent("UNIT_CASTINGTIME");
	this:RegisterEvent("UNIT_CASTINGTIME");
	_G[ this:GetName() .. "Gauge" ]:SetAlpha( 0 );
	_G[ this:GetName() .. "Anchor" ]:SetAlpha( 0.2 );
end;

function BF.events.UnitCastBarOnShow( this )
end;

function BF.events.UnitCastBarOnEvent( this, event )
	if( not BFVariables.CastBars[ this.ConfigField ].Enabled )then
		return nil;
	end;
	local gauge = _G[ this:GetName() .. "Gauge" ];
	this:SetSize( BFVariables.CastBars[ this.ConfigField ].Size, math.floor( BFVariables.CastBars[ this.ConfigField ].Size / 10 ) );
	if( event == "UNIT_CASTINGTIME" )then
		if( arg1 == this.unit )then
			local name, maxValue, currValue = UnitCastingTime( this.unit );
			if( name and maxValue > 0 )then
				_G[ gauge:GetName() .. "Name" ]:SetText( name .. " - " .. string.format( "%.1f", currValue ) .. "/" .. string.format( "%.1f", maxValue ) );
				this.fadeOut = 1;
				this.maxValue = maxValue;
				gauge:SetBarColor( 1, 0.7, 0 );
				gauge:SetMinValue( 0 );
				gauge:SetMaxValue( maxValue );
				gauge:SetValue( currValue );
				gauge:SetAlpha( 1 );
				gauge:Show();
			else
				this.maxValue = nil;
			end;
		end;
	end;
end;

function BF.events.UnitCastBarOnUpdate( this, elapsedTime )
	if( this.Lock )then return nil; end;
	if( this.unit == nil )then return nil; end;
	local gauge = _G[ this:GetName() .. "Gauge" ];
	local name, maxValue, currValue = UnitCastingTime( this.unit );
	if( name and maxValue > 0 )then
		_G[ gauge:GetName() .. "Name" ]:SetText( name .. " - " .. string.format( "%.1f", currValue ) .. "/" .. string.format( "%.1f", maxValue ) );
		this.fadeOut = 1;
		this.maxValue = maxValue;
		gauge:SetBarColor( 1, 0.7, 0 );
		gauge:SetMinValue( 0 );
		gauge:SetMaxValue( maxValue );
		gauge:SetValue( currValue );
		gauge:SetAlpha( 1 );
		gauge:Show();
	elseif( gauge:IsVisible() )then
		this.maxValue = nil;
		this.fadeOut = nil;
		gauge:Hide();
	end;
end;

function BF.events.CBAnchorMouseDown( this, key )
	if( this:GetParent().ConfigField == nil )then return nil; end;

	if( IsShiftKeyDown() )and( not IsCtrlKeyDown() )and( not IsAltKeyDown() )and( key == "RBUTTON" )then
		this.IsMoving = true;
		this:GetParent():StartMoving( "TOPLEFT" );
	end;

	if( not IsShiftKeyDown() )and( IsCtrlKeyDown() )and( not IsAltKeyDown() )and( key == "LBUTTON" )then
		local sizer = _G[ "BF" .. this:GetParent().ConfigField .. "CastBarSizer" ];
		if( sizer:IsVisible() )then
			sizer:Hide();
		else
			sizer:ClearAllAnchors();
			sizer:SetAnchor( "BOTTOMLEFT", "TOPLEFT", this, 0, -3 );
			
			sizer:SetValueStepMode("INT");
			sizer:SetMinMaxValues( 150, 260 );
			_G[ sizer:GetName() .. "Low" ]:SetText( "150" );
			_G[ sizer:GetName() .. "High" ]:SetText( "260" );
			sizer:SetValue( BFVariables.CastBars[ this:GetParent().ConfigField ].Size );
			sizer:Show();
		end;
	end;
end;

function BF.events.CBAnchorMouseUp( this )
	if( not this.IsMoving )then return nil; end;
	this:GetParent():StopMovingOrSizing();
	BFVariables.CastBars[ this:GetParent().ConfigField ]["X"], BFVariables.CastBars[ this:GetParent().ConfigField ]["Y"] = this:GetParent():GetPos();
end;

function BF.events.CBAnchorHint( this )
	if( this:GetParent().FrameName == nil )then return nil; end;
	this:SetAlpha( 1 );
	MLib.TT.Init( this, BF.Name .. " " .. BF.Version, 260, MLib.TT.AnchorType( this ), 0, 0 );
	MLib.TT.Space();
	MLib.TT.Line( this:GetParent().FrameName );
	MLib.TT.Space();
	MLib.TT.Line( "Shift + Правая кнопка мыши для перетаскивания", 0, 0.75, 0.95 );
	MLib.TT.Line( "Ctrl + Левая кнопка мыши для изменения размера", 0, 0.75, 0.95 );
end;

function BF.events.CBAnchorOnSize( this )
	GCF_Slider_OnValueChanged( this );
	if( not this:IsVisible() )then return nil; end;
	BFVariables.CastBars[ this.ConfigField ].Size = this:GetValue();
	_G[ "BF" .. this.ConfigField .. "CastBar" ]:SetSize( this:GetValue(), math.floor( this:GetValue() / 10 ) );
end;

-- /run dofile("interface/addons/mbuff/code/events.lua");