BF.tools = {};

function BF.tools.PlaceControls( parent, field )
	_G[ parent .. "Anchor" ]:SetAlpha( 0.2 );
	_G[ parent .. "1" ]:ClearAllAnchors();
	local ntexture = _G[ parent .. "Anchor" ]:GetNormalTexture();
	local ptexture = _G[ parent .. "Anchor" ]:GetPushedTexture();
	ntexture:SetColor( 1, 0, 0.6 );
	ptexture:SetColor( 1, 0, 0.6 );
	if( BFVariables[ field ].Dir == 0 )then
		ntexture:SetTexture( "interface/addons/!mlib/texture/anchors/topleft" );
		ptexture:SetTexture( "interface/addons/!mlib/texture/anchors/topleft" );
		_G[ parent .. "1" ]:SetAnchor( "TOPLEFT", "TOPLEFT", "$parent", 8, 8 );
	else
		ntexture:SetTexture( "interface/addons/!mlib/texture/anchors/topright" );
		ptexture:SetTexture( "interface/addons/!mlib/texture/anchors/topright" );
		_G[ parent .. "1" ]:SetAnchor( "TOPRIGHT", "TOPRIGHT", "$parent", -8, 8 );
	end;
	
	for n = 2, 80 do
		_G[ parent .. n ]:ClearAllAnchors();
		if( BFVariables[ field ].Dir == 0 )then
			_G[ parent .. n ]:SetAnchor( "TOPLEFT", "TOPRIGHT", "$parent" .. ( n - 1 ), 1, 0 );
		else
			_G[ parent .. n ]:SetAnchor( "TOPRIGHT", "TOPLEFT", "$parent" .. ( n - 1 ), -1, 0 );
		end;
		if( n % 10 == 1 )then
			_G[ parent .. n ]:ClearAllAnchors();
			if( BFVariables[ field ].Dir == 0 )then
				_G[ parent .. n ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", "$parent" .. ( n - 10 ), 0, 6 );
			else
				_G[ parent .. n ]:SetAnchor( "TOPRIGHT", "BOTTOMRIGHT", "$parent" .. ( n - 10 ), 0, 6 );
			end;
		end;
	end;
	
	_G[ parent .. "D1" ]:ClearAllAnchors();
	_G[ parent .. "D1" ]:SetAnchor( "TOPLEFT", "TOPLEFT", "$parent", 8, 8 );
	for n = 2, 80 do
		_G[ parent .. "D" .. n ]:ClearAllAnchors();
		if( BFVariables[ field ].Dir == 0 )then
			_G[ parent .. "D" .. n ]:SetAnchor( "TOPLEFT", "TOPRIGHT", "$parentD" .. ( n - 1 ), 1, 0 );
		else
			_G[ parent .. "D" .. n ]:SetAnchor( "TOPRIGHT", "TOPLEFT", "$parentD" .. ( n - 1 ), -1, 0 );
		end;
		if( n % 10 == 1 )then
			_G[ parent .. "D" .. n ]:ClearAllAnchors();
			if( BFVariables[ field ].Dir == 0 )then
				_G[ parent .. "D" .. n ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", "$parentD" .. ( n - 10 ), 0, 6 );
			else
				_G[ parent .. "D" .. n ]:SetAnchor( "TOPRIGHT", "BOTTOMRIGHT", "$parentD" .. ( n - 10 ), 0, 6 );
			end;
		end;
	end;
	
	for n = 1, 80 do
		_G[ parent .. n ]:SetSize( BFVariables[ field ].Size, BFVariables[ field ].Size );
		_G[ parent .. "D" .. n ]:SetSize( BFVariables[ field ].Size, BFVariables[ field ].Size );
	end;
end;

function BF.tools.PaintControls( parent, field, buffs, debuffs )
	for n = 1, 80 do
		if( buffs[ n ] == nil )then
			_G[ parent .. n ]:Hide();
		else
			local item = _G[ parent .. n ];
			item:Show();
			_G[ item:GetName() .. "Icon" ]:SetTexture( item.struc.icon );
			if( item.struc.leftTime ~= nil )then
				_G[ item:GetName() .. "Time" ]:SetText( item.struc.time );
			else
				_G[ item:GetName() .. "Time" ]:SetText( "" );
			end;
			if( item.struc.stack > 0 )then
				_G[ item:GetName() .. "Stack" ]:Show();
				_G[ item:GetName() .. "Stack" ]:SetText( item.struc.stack );
			else
				_G[ item:GetName() .. "Stack" ]:Hide();
			end;
			_G[ item:GetName() .. "Gauge" ]:SetBarColor( 0.3, 1, 0.3 );
			if( item.struc.percent < 20 )then
				_G[ item:GetName() .. "Gauge" ]:SetBarColor( 1, 0.2, 0.2 );
			elseif( item.struc.percent < 40 )then
				_G[ item:GetName() .. "Gauge" ]:SetBarColor( 1, 0.6, 0 );
			end;
			_G[ item:GetName() .. "Gauge" ]:SetValue( item.struc.percent );
		end;
	end;
	
	if( #buffs < 1 )then
		_G[ parent .. "Count" ]:SetText( "" );
	else
		_G[ parent .. "Count" ]:SetText( #buffs );
	end;
	_G[ parent .. "Count" ]:Show();
	
	_G[ parent .. "D1" ]:ClearAllAnchors();
	local relativeTo = "$parent";
	local X, Y = 8, 8;
	if( BFVariables[ field ].Dir ~= 0 )then X= -8; end;
	if( #buffs > 70 )then relativeTo = "$parent71";
	elseif( #buffs > 60 )then relativeTo = "$parent61";
	elseif( #buffs > 50 )then relativeTo = "$parent51";
	elseif( #buffs > 40 )then relativeTo = "$parent41";
	elseif( #buffs > 30 )then relativeTo = "$parent31";
	elseif( #buffs > 20 )then relativeTo = "$parent21";
	elseif( #buffs > 10 )then relativeTo = "$parent11";
	elseif( #buffs > 1 )then relativeTo = "$parent1"; end;
	
	if( relativeTo ~= "$parent" )then X = 0; Y = 12; end;
	
	if( BFVariables[ field ].Dir == 0 )then
		_G[ parent .. "D1" ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", relativeTo, X, Y );
	else
		_G[ parent .. "D1" ]:SetAnchor( "TOPRIGHT", "BOTTOMRIGHT", relativeTo, X, Y );
	end;
	
	for n = 1, 80 do
		if( debuffs[ n ] == nil )then
			_G[ parent .. "D" .. n ]:Hide();
		else
			local item = _G[ parent .. "D" .. n ];
			item:Show();
			_G[ item:GetName() .. "Icon" ]:SetTexture( item.struc.icon );
			if( item.struc.leftTime ~= nil )then
				_G[ item:GetName() .. "Time" ]:SetText( item.struc.time );
			else
				_G[ item:GetName() .. "Time" ]:SetText( "" );
			end;
			if( item.struc.stack > 0 )then
				_G[ item:GetName() .. "Stack" ]:Show();
				_G[ item:GetName() .. "Stack" ]:SetText( item.struc.stack );
			else
				_G[ item:GetName() .. "Stack" ]:Hide();
			end;
			_G[ item:GetName() .. "Gauge" ]:SetBarColor( 1, 0.2, 0.2 );
			_G[ item:GetName() .. "Gauge" ]:SetValue( item.struc.percent );
			
			_G[ item:GetName() .. "Quality" ]:SetColor( 0.5, 0, 0 );
			if( BFVariables.Curses[ item.struc.guid ] )then
				_G[ item:GetName() .. "Quality" ]:SetColor( 0, 0, 0.5 );
				_G[ item:GetName() .. "Gauge" ]:SetBarColor( 0, 0, 0.5 );
			end;
			if( BFVariables.Poisons[ item.struc.guid ] )then
				_G[ item:GetName() .. "Quality" ]:SetColor( 0, 0.5, 0 );
				_G[ item:GetName() .. "Gauge" ]:SetBarColor( 0, 0.5, 0 );
			end;
			_G[ item:GetName() .. "Quality" ]:Show();
			_G[ parent .. "D" .. n .. "Quality" ]:ClearAllAnchors();
			_G[ parent .. "D" .. n .. "Quality" ]:SetAnchor( "CENTER", "CENTER", "$parent", 0, 0 );
			local delta = BFVariables[ field ].Size * 2.2;
			_G[ parent .. "D" .. n .. "Quality" ]:SetSize( delta, delta );
		end;
	end;
end;

function BF.tools.GrabUnitBuffs( unit, _type )
	if( _type == nil )then _type = "buff"; end;
	local Buffs = {};
	
	for n = 1, 80 do
		if( _type == "buff" )then
			local name, icon, count, buffID = UnitBuff( unit, n );
			if( buffID ~= nil )then
				local leftTime = UnitBuffLeftTime( unit, n );
				
				local _time = "";
				local _percent = 100;
				if( leftTime ~= nil )then
					if( BFVariables.Buffs == nil )then BFVariables.Buffs = {}; end;
					if( BFVariables.Buffs[ buffID ] == nil )then BFVariables.Buffs[ buffID ] = leftTime; end;
					if( BFVariables.Buffs[ buffID ] < leftTime )then BFVariables.Buffs[ buffID ] = leftTime; end;

					local max = BFVariables.Buffs[ buffID ];
					_percent = math.floor( leftTime * 100 / max );
					_time = string.format( "%.1f", leftTime );
					if( leftTime > 60 )then
						_time = math.floor( leftTime / 60 ) .. getglobal("UNIT_MINUTE");
					end;
					if( leftTime > 3600 )then
						_time = math.floor( leftTime / 3600 ) .. getglobal("UNIT_HOUR");
					end;
					if( leftTime > 86400 )then
						_time = math.floor( leftTime / 86400 ) .. getglobal("UNIT_DAY");
					end;
				end;
				Buffs[ #Buffs + 1 ] = {
					["unit"] = unit,
					["type"] = "buff",
					["index"] = n,
					["name"] = name,
					["icon"] = icon,
					["stack"] = count,
					["guid"] = buffID,
					["leftTime"] = leftTime,
					["percent"] = _percent,
					["time"] = _time,
				};
			end;
		else
			local name, icon, count, buffID = UnitDebuff( unit, n );
			if( buffID ~= nil )then
				local leftTime = UnitDebuffLeftTime( unit, n );
				
				local _time = "";
				local _percent = 100;
				if( leftTime ~= nil )then
					if( BFVariables.Buffs == nil )then BFVariables.Buffs = {}; end;
					if( BFVariables.Buffs[ buffID ] == nil )then BFVariables.Buffs[ buffID ] = leftTime; end;
					if( BFVariables.Buffs[ buffID ] < leftTime )then BFVariables.Buffs[ buffID ] = leftTime; end;

					local max = BFVariables.Buffs[ buffID ];
					_percent = math.floor( leftTime * 100 / max );
					_time = string.format( "%.1f", leftTime );
					if( leftTime > 60 )then
						_time = math.floor( leftTime / 60 ) .. getglobal("UNIT_MINUTE");
					end;
					if( leftTime > 3600 )then
						_time = math.floor( leftTime / 3600 ) .. getglobal("UNIT_HOUR");
					end;
					if( leftTime > 86400 )then
						_time = math.floor( leftTime / 86400 ) .. getglobal("UNIT_DAY");
					end;
				end;
				Buffs[ #Buffs + 1 ] = {
					["unit"] = unit,
					["type"] = "debuff",
					["index"] = n,
					["name"] = name,
					["icon"] = icon,
					["stack"] = count,
					["guid"] = buffID,
					["leftTime"] = leftTime,
					["percent"] = _percent,
					["time"] = _time,
				};
			end;
		end;
	end;
	
	return Buffs;
end;

-- /run dofile("interface/addons/mbuff/code/tools.lua");